# printnanny-factory-rest-api
Documentation of API endpoints of printnanny-factory

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0 
- Package version: 0.1.0rc202308191701
- Build date: 2023-08-19T17:01:45.735971-07:00[America/Los_Angeles]
- Build package: org.openapitools.codegen.languages.PythonNextgenClientCodegen
For more information, please visit [http://aurora:8000](http://aurora:8000)

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import printnanny_factory_rest_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import printnanny_factory_rest_api
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import printnanny_factory_rest_api
from printnanny_factory_rest_api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = printnanny_factory_rest_api.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: cookieAuth
configuration.api_key['cookieAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['cookieAuth'] = 'Bearer'


# Enter a context with an instance of the API client
async with printnanny_factory_rest_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = printnanny_factory_rest_api.AuthApi(api_client)
    email_auth_redirect_request = printnanny_factory_rest_api.EmailAuthRedirectRequest() # EmailAuthRedirectRequest | 

    try:
        api_response = await api_instance.auth_send_email_create(email_auth_redirect_request)
        print("The response of AuthApi->auth_send_email_create:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AuthApi->auth_send_email_create: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthApi* | [**auth_send_email_create**](docs/AuthApi.md#auth_send_email_create) | **POST** /api/auth/send-email/ | 
*AuthApi* | [**auth_verify_email_create**](docs/AuthApi.md#auth_verify_email_create) | **POST** /api/auth/verify-email/ | 
*AuthApi* | [**o_introspect_create**](docs/AuthApi.md#o_introspect_create) | **POST** /api/o/introspect/ | 
*AuthApi* | [**o_introspect_retrieve**](docs/AuthApi.md#o_introspect_retrieve) | **GET** /api/o/introspect/ | 
*AuthApi* | [**o_token_create**](docs/AuthApi.md#o_token_create) | **POST** /api/o/token/ | 
*PrintersApi* | [**oems_create**](docs/PrintersApi.md#oems_create) | **POST** /api/oems/ | 
*PrintersApi* | [**oems_list**](docs/PrintersApi.md#oems_list) | **GET** /api/oems/ | 
*PrintersApi* | [**oems_retrieve**](docs/PrintersApi.md#oems_retrieve) | **GET** /api/oems/{id}/ | 
*PrintersApi* | [**workspaces_printers_application_create**](docs/PrintersApi.md#workspaces_printers_application_create) | **POST** /api/workspaces/{workspace_id}/printers/{id}/application/ | 
*PrintersApi* | [**workspaces_printers_create**](docs/PrintersApi.md#workspaces_printers_create) | **POST** /api/workspaces/{workspace_id}/printers/ | 
*PrintersApi* | [**workspaces_printers_duet_partial_update**](docs/PrintersApi.md#workspaces_printers_duet_partial_update) | **PATCH** /api/workspaces/{workspace_id}/printers/{printer_id}/duet/ | 
*PrintersApi* | [**workspaces_printers_duet_retrieve**](docs/PrintersApi.md#workspaces_printers_duet_retrieve) | **GET** /api/workspaces/{workspace_id}/printers/{printer_id}/duet/ | 
*PrintersApi* | [**workspaces_printers_duet_update**](docs/PrintersApi.md#workspaces_printers_duet_update) | **PUT** /api/workspaces/{workspace_id}/printers/{printer_id}/duet/ | 
*PrintersApi* | [**workspaces_printers_list**](docs/PrintersApi.md#workspaces_printers_list) | **GET** /api/workspaces/{workspace_id}/printers/ | 
*PrintersApi* | [**workspaces_printers_partial_update**](docs/PrintersApi.md#workspaces_printers_partial_update) | **PATCH** /api/workspaces/{workspace_id}/printers/{id}/ | 
*PrintersApi* | [**workspaces_printers_retrieve**](docs/PrintersApi.md#workspaces_printers_retrieve) | **GET** /api/workspaces/{workspace_id}/printers/{id}/ | 
*PrintersApi* | [**workspaces_printers_update**](docs/PrintersApi.md#workspaces_printers_update) | **PUT** /api/workspaces/{workspace_id}/printers/{id}/ | 
*ReservationsApi* | [**workspaces_reservations_create**](docs/ReservationsApi.md#workspaces_reservations_create) | **POST** /api/workspaces/{workspace_id}/reservations/ | 
*ReservationsApi* | [**workspaces_reservations_destroy**](docs/ReservationsApi.md#workspaces_reservations_destroy) | **DELETE** /api/workspaces/{workspace_id}/reservations/{id}/ | 
*ReservationsApi* | [**workspaces_reservations_list**](docs/ReservationsApi.md#workspaces_reservations_list) | **GET** /api/workspaces/{workspace_id}/reservations/ | 
*ReservationsApi* | [**workspaces_reservations_partial_update**](docs/ReservationsApi.md#workspaces_reservations_partial_update) | **PATCH** /api/workspaces/{workspace_id}/reservations/{id}/ | 
*ReservationsApi* | [**workspaces_reservations_retrieve**](docs/ReservationsApi.md#workspaces_reservations_retrieve) | **GET** /api/workspaces/{workspace_id}/reservations/{id}/ | 
*ReservationsApi* | [**workspaces_reservations_update**](docs/ReservationsApi.md#workspaces_reservations_update) | **PUT** /api/workspaces/{workspace_id}/reservations/{id}/ | 
*SchemaApi* | [**schema_retrieve**](docs/SchemaApi.md#schema_retrieve) | **GET** /api/schema/ | 
*UsersApi* | [**users_me_retrieve**](docs/UsersApi.md#users_me_retrieve) | **GET** /api/users/me/ | 
*UsersApi* | [**users_partial_update**](docs/UsersApi.md#users_partial_update) | **PATCH** /api/users/{id}/ | 
*UsersApi* | [**users_update**](docs/UsersApi.md#users_update) | **PUT** /api/users/{id}/ | 
*WorkspacesApi* | [**workspaces_applications_destroy**](docs/WorkspacesApi.md#workspaces_applications_destroy) | **DELETE** /api/workspaces/{workspace_id}/applications/{id}/ | 
*WorkspacesApi* | [**workspaces_applications_list**](docs/WorkspacesApi.md#workspaces_applications_list) | **GET** /api/workspaces/{workspace_id}/applications/ | 
*WorkspacesApi* | [**workspaces_create**](docs/WorkspacesApi.md#workspaces_create) | **POST** /api/workspaces/ | 
*WorkspacesApi* | [**workspaces_destroy**](docs/WorkspacesApi.md#workspaces_destroy) | **DELETE** /api/workspaces/{id}/ | 
*WorkspacesApi* | [**workspaces_invites_create**](docs/WorkspacesApi.md#workspaces_invites_create) | **POST** /api/workspaces/{workspace_id}/invites/ | 
*WorkspacesApi* | [**workspaces_invites_list**](docs/WorkspacesApi.md#workspaces_invites_list) | **GET** /api/workspaces/{workspace_id}/invites/ | 
*WorkspacesApi* | [**workspaces_invites_retrieve**](docs/WorkspacesApi.md#workspaces_invites_retrieve) | **GET** /api/workspaces/{workspace_id}/invites/{id}/ | 
*WorkspacesApi* | [**workspaces_list**](docs/WorkspacesApi.md#workspaces_list) | **GET** /api/workspaces/ | 
*WorkspacesApi* | [**workspaces_partial_update**](docs/WorkspacesApi.md#workspaces_partial_update) | **PATCH** /api/workspaces/{id}/ | 
*WorkspacesApi* | [**workspaces_printers_destroy**](docs/WorkspacesApi.md#workspaces_printers_destroy) | **DELETE** /api/workspaces/{workspace_id}/printers/{id}/ | 
*WorkspacesApi* | [**workspaces_retrieve**](docs/WorkspacesApi.md#workspaces_retrieve) | **GET** /api/workspaces/{id}/ | 
*WorkspacesApi* | [**workspaces_update**](docs/WorkspacesApi.md#workspaces_update) | **PUT** /api/workspaces/{id}/ | 


## Documentation For Models

 - [AuthorizationGrantTypeEnum](docs/AuthorizationGrantTypeEnum.md)
 - [CallbackTokenAuthRequest](docs/CallbackTokenAuthRequest.md)
 - [ClientTypeEnum](docs/ClientTypeEnum.md)
 - [DuetPrinterBackend](docs/DuetPrinterBackend.md)
 - [DuetPrinterBackendRequest](docs/DuetPrinterBackendRequest.md)
 - [DuetPrinterBackendStatusEnum](docs/DuetPrinterBackendStatusEnum.md)
 - [EmailAuthRedirect](docs/EmailAuthRedirect.md)
 - [EmailAuthRedirectRequest](docs/EmailAuthRedirectRequest.md)
 - [ErrorDetail](docs/ErrorDetail.md)
 - [GrantTypeEnum](docs/GrantTypeEnum.md)
 - [MaintenanceJob](docs/MaintenanceJob.md)
 - [MaintenanceJobAllOf](docs/MaintenanceJobAllOf.md)
 - [MaintenanceJobRequest](docs/MaintenanceJobRequest.md)
 - [MaintenanceJobRequestAllOf](docs/MaintenanceJobRequestAllOf.md)
 - [MaintenanceJobTyped](docs/MaintenanceJobTyped.md)
 - [MaintenanceJobTypedAllOf](docs/MaintenanceJobTypedAllOf.md)
 - [MaintenanceJobTypedRequest](docs/MaintenanceJobTypedRequest.md)
 - [Oauth2Application](docs/Oauth2Application.md)
 - [Oauth2ApplicationRequest](docs/Oauth2ApplicationRequest.md)
 - [Oauth2Introspect](docs/Oauth2Introspect.md)
 - [Oauth2IntrospectRequest](docs/Oauth2IntrospectRequest.md)
 - [Oauth2Token](docs/Oauth2Token.md)
 - [Oauth2TokenRequestRequest](docs/Oauth2TokenRequestRequest.md)
 - [PatchedDuetPrinterBackendRequest](docs/PatchedDuetPrinterBackendRequest.md)
 - [PatchedMaintenanceJobRequest](docs/PatchedMaintenanceJobRequest.md)
 - [PatchedMaintenanceJobRequestAllOf](docs/PatchedMaintenanceJobRequestAllOf.md)
 - [PatchedMaintenanceJobTypedRequest](docs/PatchedMaintenanceJobTypedRequest.md)
 - [PatchedMaintenanceJobTypedRequestAllOf](docs/PatchedMaintenanceJobTypedRequestAllOf.md)
 - [PatchedPrintJobRequest](docs/PatchedPrintJobRequest.md)
 - [PatchedPrintJobRequestAllOf](docs/PatchedPrintJobRequestAllOf.md)
 - [PatchedPrintJobTypedRequest](docs/PatchedPrintJobTypedRequest.md)
 - [PatchedPrinterRequest](docs/PatchedPrinterRequest.md)
 - [PatchedPrinterReservationPolymorphicRequest](docs/PatchedPrinterReservationPolymorphicRequest.md)
 - [PatchedPrinterReservationRequest](docs/PatchedPrinterReservationRequest.md)
 - [PatchedPrinterReservationTypedRequest](docs/PatchedPrinterReservationTypedRequest.md)
 - [PatchedUserRequest](docs/PatchedUserRequest.md)
 - [PatchedWorkspaceRequest](docs/PatchedWorkspaceRequest.md)
 - [PrintJob](docs/PrintJob.md)
 - [PrintJobAllOf](docs/PrintJobAllOf.md)
 - [PrintJobRequest](docs/PrintJobRequest.md)
 - [PrintJobRequestAllOf](docs/PrintJobRequestAllOf.md)
 - [PrintJobStatus](docs/PrintJobStatus.md)
 - [PrintJobTyped](docs/PrintJobTyped.md)
 - [PrintJobTypedRequest](docs/PrintJobTypedRequest.md)
 - [Printer](docs/Printer.md)
 - [PrinterBackend](docs/PrinterBackend.md)
 - [PrinterCreateRequest](docs/PrinterCreateRequest.md)
 - [PrinterOEM](docs/PrinterOEM.md)
 - [PrinterOEMRequest](docs/PrinterOEMRequest.md)
 - [PrinterOauthApplicationCreateRequest](docs/PrinterOauthApplicationCreateRequest.md)
 - [PrinterRequest](docs/PrinterRequest.md)
 - [PrinterReservation](docs/PrinterReservation.md)
 - [PrinterReservationPolymorphic](docs/PrinterReservationPolymorphic.md)
 - [PrinterReservationPolymorphicRequest](docs/PrinterReservationPolymorphicRequest.md)
 - [PrinterReservationRequest](docs/PrinterReservationRequest.md)
 - [PrinterReservationTyped](docs/PrinterReservationTyped.md)
 - [PrinterReservationTypedRequest](docs/PrinterReservationTypedRequest.md)
 - [User](docs/User.md)
 - [UserRequest](docs/UserRequest.md)
 - [Workspace](docs/Workspace.md)
 - [WorkspaceInvitation](docs/WorkspaceInvitation.md)
 - [WorkspaceInvitationRequest](docs/WorkspaceInvitationRequest.md)
 - [WorkspaceOwner](docs/WorkspaceOwner.md)
 - [WorkspaceOwnerRequest](docs/WorkspaceOwnerRequest.md)
 - [WorkspaceRequest](docs/WorkspaceRequest.md)
 - [WorkspaceUser](docs/WorkspaceUser.md)
 - [WorkspaceUserRequest](docs/WorkspaceUserRequest.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="cookieAuth"></a>
### cookieAuth

- **Type**: API key
- **API key parameter name**: sessionid
- **Location**: 

<a id="oauth2"></a>
### oauth2

- **Type**: OAuth
- **Flow**: password
- **Authorization URL**: 
- **Scopes**: 
 - **read**: Read
 - **write**: Write
 - **printer:read**: Read 3D printer status/data
 - **printer:write**: Write to 3D printer backend

<a id="oauth2"></a>
### oauth2

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: /api/o/authorize/
- **Scopes**: 
 - **read**: Read
 - **write**: Write
 - **printer:read**: Read 3D printer status/data
 - **printer:write**: Write to 3D printer backend

<a id="oauth2"></a>
### oauth2

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - **read**: Read
 - **write**: Write
 - **printer:read**: Read 3D printer status/data
 - **printer:write**: Write to 3D printer backend

<a id="oauth2"></a>
### oauth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: /api/o/authorize/
- **Scopes**: 
 - **read**: Read
 - **write**: Write
 - **printer:read**: Read 3D printer status/data
 - **printer:write**: Write to 3D printer backend


## Author

leigh@printnanny.ai


