# coding: utf-8

"""
    PrintNanny Factory API Documentation

    Documentation of API endpoints of printnanny-factory  # noqa: E501

    The version of the OpenAPI document: 0.1.0 
    Contact: leigh@printnanny.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated
from typing import overload, Optional, Union, Awaitable

from pydantic import Field, StrictStr

from typing import List, Optional

from printnanny_factory_rest_api.models.patched_printer_reservation_polymorphic_request import PatchedPrinterReservationPolymorphicRequest
from printnanny_factory_rest_api.models.printer_reservation_polymorphic import PrinterReservationPolymorphic
from printnanny_factory_rest_api.models.printer_reservation_polymorphic_request import PrinterReservationPolymorphicRequest

from printnanny_factory_rest_api.api_client import ApiClient
from printnanny_factory_rest_api.api_response import ApiResponse
from printnanny_factory_rest_api.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ReservationsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @overload
    async def workspaces_reservations_create(self, workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @overload
    def workspaces_reservations_create(self, workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, async_req: Optional[bool]=True, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @validate_arguments
    def workspaces_reservations_create(self, workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, async_req: Optional[bool]=None, **kwargs) -> Union[PrinterReservationPolymorphic, Awaitable[PrinterReservationPolymorphic]]:  # noqa: E501
        """workspaces_reservations_create  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_create(workspace_id, printer_reservation_polymorphic_request, async_req=True)
        >>> result = thread.get()

        :param workspace_id: (required)
        :type workspace_id: str
        :param printer_reservation_polymorphic_request:
        :type printer_reservation_polymorphic_request: PrinterReservationPolymorphicRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PrinterReservationPolymorphic
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the workspaces_reservations_create_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.workspaces_reservations_create_with_http_info(workspace_id, printer_reservation_polymorphic_request, **kwargs)  # noqa: E501

    @validate_arguments
    def workspaces_reservations_create_with_http_info(self, workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """workspaces_reservations_create  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_create_with_http_info(workspace_id, printer_reservation_polymorphic_request, async_req=True)
        >>> result = thread.get()

        :param workspace_id: (required)
        :type workspace_id: str
        :param printer_reservation_polymorphic_request:
        :type printer_reservation_polymorphic_request: PrinterReservationPolymorphicRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PrinterReservationPolymorphic, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'workspace_id',
            'printer_reservation_polymorphic_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method workspaces_reservations_create" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['workspace_id']:
            _path_params['workspace_id'] = _params['workspace_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['printer_reservation_polymorphic_request'] is not None:
            _body_params = _params['printer_reservation_polymorphic_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['cookieAuth']  # noqa: E501

        _response_types_map = {
            '201': "PrinterReservationPolymorphic",
            '400': "ErrorDetail",
            '409': "ErrorDetail",
            '401': "ErrorDetail",
            '403': "ErrorDetail",
            '500': "ErrorDetail",
        }

        return self.api_client.call_api(
            '/api/workspaces/{workspace_id}/reservations/', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def workspaces_reservations_destroy(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, **kwargs) -> None:  # noqa: E501
        ...

    @overload
    def workspaces_reservations_destroy(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, async_req: Optional[bool]=True, **kwargs) -> None:  # noqa: E501
        ...

    @validate_arguments
    def workspaces_reservations_destroy(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, async_req: Optional[bool]=None, **kwargs) -> Union[None, Awaitable[None]]:  # noqa: E501
        """workspaces_reservations_destroy  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_destroy(id, workspace_id, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the workspaces_reservations_destroy_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.workspaces_reservations_destroy_with_http_info(id, workspace_id, **kwargs)  # noqa: E501

    @validate_arguments
    def workspaces_reservations_destroy_with_http_info(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """workspaces_reservations_destroy  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_destroy_with_http_info(id, workspace_id, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = [
            'id',
            'workspace_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method workspaces_reservations_destroy" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['workspace_id']:
            _path_params['workspace_id'] = _params['workspace_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # authentication setting
        _auth_settings = ['cookieAuth']  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            '/api/workspaces/{workspace_id}/reservations/{id}/', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def workspaces_reservations_list(self, workspace_id : StrictStr, **kwargs) -> List[PrinterReservationPolymorphic]:  # noqa: E501
        ...

    @overload
    def workspaces_reservations_list(self, workspace_id : StrictStr, async_req: Optional[bool]=True, **kwargs) -> List[PrinterReservationPolymorphic]:  # noqa: E501
        ...

    @validate_arguments
    def workspaces_reservations_list(self, workspace_id : StrictStr, async_req: Optional[bool]=None, **kwargs) -> Union[List[PrinterReservationPolymorphic], Awaitable[List[PrinterReservationPolymorphic]]]:  # noqa: E501
        """workspaces_reservations_list  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_list(workspace_id, async_req=True)
        >>> result = thread.get()

        :param workspace_id: (required)
        :type workspace_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[PrinterReservationPolymorphic]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the workspaces_reservations_list_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.workspaces_reservations_list_with_http_info(workspace_id, **kwargs)  # noqa: E501

    @validate_arguments
    def workspaces_reservations_list_with_http_info(self, workspace_id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """workspaces_reservations_list  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_list_with_http_info(workspace_id, async_req=True)
        >>> result = thread.get()

        :param workspace_id: (required)
        :type workspace_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[PrinterReservationPolymorphic], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'workspace_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method workspaces_reservations_list" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['workspace_id']:
            _path_params['workspace_id'] = _params['workspace_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['cookieAuth']  # noqa: E501

        _response_types_map = {
            '200': "List[PrinterReservationPolymorphic]",
            '401': "ErrorDetail",
            '403': "ErrorDetail",
            '500': "ErrorDetail",
        }

        return self.api_client.call_api(
            '/api/workspaces/{workspace_id}/reservations/', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def workspaces_reservations_partial_update(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, patched_printer_reservation_polymorphic_request : Optional[PatchedPrinterReservationPolymorphicRequest] = None, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @overload
    def workspaces_reservations_partial_update(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, patched_printer_reservation_polymorphic_request : Optional[PatchedPrinterReservationPolymorphicRequest] = None, async_req: Optional[bool]=True, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @validate_arguments
    def workspaces_reservations_partial_update(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, patched_printer_reservation_polymorphic_request : Optional[PatchedPrinterReservationPolymorphicRequest] = None, async_req: Optional[bool]=None, **kwargs) -> Union[PrinterReservationPolymorphic, Awaitable[PrinterReservationPolymorphic]]:  # noqa: E501
        """workspaces_reservations_partial_update  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_partial_update(id, workspace_id, patched_printer_reservation_polymorphic_request, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param patched_printer_reservation_polymorphic_request:
        :type patched_printer_reservation_polymorphic_request: PatchedPrinterReservationPolymorphicRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PrinterReservationPolymorphic
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the workspaces_reservations_partial_update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.workspaces_reservations_partial_update_with_http_info(id, workspace_id, patched_printer_reservation_polymorphic_request, **kwargs)  # noqa: E501

    @validate_arguments
    def workspaces_reservations_partial_update_with_http_info(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, patched_printer_reservation_polymorphic_request : Optional[PatchedPrinterReservationPolymorphicRequest] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """workspaces_reservations_partial_update  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_partial_update_with_http_info(id, workspace_id, patched_printer_reservation_polymorphic_request, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param patched_printer_reservation_polymorphic_request:
        :type patched_printer_reservation_polymorphic_request: PatchedPrinterReservationPolymorphicRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PrinterReservationPolymorphic, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'workspace_id',
            'patched_printer_reservation_polymorphic_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method workspaces_reservations_partial_update" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['workspace_id']:
            _path_params['workspace_id'] = _params['workspace_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['patched_printer_reservation_polymorphic_request'] is not None:
            _body_params = _params['patched_printer_reservation_polymorphic_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['cookieAuth']  # noqa: E501

        _response_types_map = {
            '200': "PrinterReservationPolymorphic",
            '400': "ErrorDetail",
            '409': "ErrorDetail",
            '401': "ErrorDetail",
            '403': "ErrorDetail",
            '500': "ErrorDetail",
        }

        return self.api_client.call_api(
            '/api/workspaces/{workspace_id}/reservations/{id}/', 'PATCH',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def workspaces_reservations_retrieve(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @overload
    def workspaces_reservations_retrieve(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, async_req: Optional[bool]=True, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @validate_arguments
    def workspaces_reservations_retrieve(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, async_req: Optional[bool]=None, **kwargs) -> Union[PrinterReservationPolymorphic, Awaitable[PrinterReservationPolymorphic]]:  # noqa: E501
        """workspaces_reservations_retrieve  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_retrieve(id, workspace_id, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PrinterReservationPolymorphic
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the workspaces_reservations_retrieve_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.workspaces_reservations_retrieve_with_http_info(id, workspace_id, **kwargs)  # noqa: E501

    @validate_arguments
    def workspaces_reservations_retrieve_with_http_info(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """workspaces_reservations_retrieve  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_retrieve_with_http_info(id, workspace_id, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PrinterReservationPolymorphic, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'workspace_id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method workspaces_reservations_retrieve" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['workspace_id']:
            _path_params['workspace_id'] = _params['workspace_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['cookieAuth']  # noqa: E501

        _response_types_map = {
            '200': "PrinterReservationPolymorphic",
            '404': "ErrorDetail",
            '401': "ErrorDetail",
            '403': "ErrorDetail",
            '500': "ErrorDetail",
        }

        return self.api_client.call_api(
            '/api/workspaces/{workspace_id}/reservations/{id}/', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def workspaces_reservations_update(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @overload
    def workspaces_reservations_update(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, async_req: Optional[bool]=True, **kwargs) -> PrinterReservationPolymorphic:  # noqa: E501
        ...

    @validate_arguments
    def workspaces_reservations_update(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, async_req: Optional[bool]=None, **kwargs) -> Union[PrinterReservationPolymorphic, Awaitable[PrinterReservationPolymorphic]]:  # noqa: E501
        """workspaces_reservations_update  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_update(id, workspace_id, printer_reservation_polymorphic_request, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param printer_reservation_polymorphic_request:
        :type printer_reservation_polymorphic_request: PrinterReservationPolymorphicRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PrinterReservationPolymorphic
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the workspaces_reservations_update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.workspaces_reservations_update_with_http_info(id, workspace_id, printer_reservation_polymorphic_request, **kwargs)  # noqa: E501

    @validate_arguments
    def workspaces_reservations_update_with_http_info(self, id : Annotated[StrictStr, Field(..., description="A unique integer value identifying this printer reservation.")], workspace_id : StrictStr, printer_reservation_polymorphic_request : Optional[PrinterReservationPolymorphicRequest] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """workspaces_reservations_update  # noqa: E501

        Intended for use with ViewSets registered using rest_framework_nested.routers.NestedSimpleRouter  Looks up workspace object  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.workspaces_reservations_update_with_http_info(id, workspace_id, printer_reservation_polymorphic_request, async_req=True)
        >>> result = thread.get()

        :param id: A unique integer value identifying this printer reservation. (required)
        :type id: str
        :param workspace_id: (required)
        :type workspace_id: str
        :param printer_reservation_polymorphic_request:
        :type printer_reservation_polymorphic_request: PrinterReservationPolymorphicRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PrinterReservationPolymorphic, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'workspace_id',
            'printer_reservation_polymorphic_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method workspaces_reservations_update" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['workspace_id']:
            _path_params['workspace_id'] = _params['workspace_id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['printer_reservation_polymorphic_request'] is not None:
            _body_params = _params['printer_reservation_polymorphic_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['cookieAuth']  # noqa: E501

        _response_types_map = {
            '200': "PrinterReservationPolymorphic",
            '400': "ErrorDetail",
            '409': "ErrorDetail",
            '401': "ErrorDetail",
            '403': "ErrorDetail",
            '500': "ErrorDetail",
        }

        return self.api_client.call_api(
            '/api/workspaces/{workspace_id}/reservations/{id}/', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
