# coding: utf-8

"""
    PrintNanny Factory API Documentation

    Documentation of API endpoints of printnanny-factory  # noqa: E501

    The version of the OpenAPI document: 0.1.0 
    Contact: leigh@printnanny.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictBool, StrictStr, constr

class PatchedPrinterRequest(BaseModel):
    """
    PatchedPrinterRequest
    """
    name: Optional[constr(strict=True, max_length=255, min_length=1)] = None
    bed_cleared: Optional[StrictBool] = None
    filament: Optional[StrictStr] = None
    nozzle: Optional[StrictStr] = None
    bed: Optional[StrictStr] = None
    __properties = ["name", "bed_cleared", "filament", "nozzle", "bed"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchedPrinterRequest:
        """Create an instance of PatchedPrinterRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if filament (nullable) is None
        # and __fields_set__ contains the field
        if self.filament is None and "filament" in self.__fields_set__:
            _dict['filament'] = None

        # set to None if nozzle (nullable) is None
        # and __fields_set__ contains the field
        if self.nozzle is None and "nozzle" in self.__fields_set__:
            _dict['nozzle'] = None

        # set to None if bed (nullable) is None
        # and __fields_set__ contains the field
        if self.bed is None and "bed" in self.__fields_set__:
            _dict['bed'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchedPrinterRequest:
        """Create an instance of PatchedPrinterRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PatchedPrinterRequest.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in PatchedPrinterRequest) in the input: " + obj)

        _obj = PatchedPrinterRequest.parse_obj({
            "name": obj.get("name"),
            "bed_cleared": obj.get("bed_cleared"),
            "filament": obj.get("filament"),
            "nozzle": obj.get("nozzle"),
            "bed": obj.get("bed")
        })
        return _obj

