# coding: utf-8

"""
    PrintNanny Factory API Documentation

    Documentation of API endpoints of printnanny-factory  # noqa: E501

    The version of the OpenAPI document: 0.1.0 
    Contact: leigh@printnanny.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
import printnanny_factory_rest_api.models

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, StrictStr, constr

class PatchedPrinterReservationPolymorphicRequest(BaseModel):
    """
    PatchedPrinterReservationPolymorphicRequest
    """
    created_by: Optional[StrictStr] = None
    end_dt: Optional[datetime] = None
    notes: Optional[StrictStr] = None
    printer: Optional[StrictStr] = None
    start_dt: Optional[datetime] = None
    title: Optional[constr(strict=True, max_length=255, min_length=1)] = None
    workspace: Optional[StrictStr] = None
    __properties = ["created_by", "end_dt", "notes", "printer", "start_dt", "title", "workspace"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    # JSON field name that stores the object type
    __discriminator_property_name = 'resourcetype'

    # discriminator mappings
    __discriminator_value_class_map = {
        'MaintenanceJob': 'PatchedMaintenanceJobTypedRequest',
        'PatchedMaintenanceJobRequest': 'PatchedMaintenanceJobRequest',
        'PatchedPrintJobRequest': 'PatchedPrintJobRequest',
        'PatchedPrinterReservationRequest': 'PatchedPrinterReservationRequest',
        'PrintJob': 'PatchedPrintJobTypedRequest',
        'PrinterReservation': 'PatchedPrinterReservationTypedRequest'
    }

    @classmethod
    def get_discriminator_value(cls, obj: dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union(PatchedMaintenanceJobRequest, PatchedMaintenanceJobTypedRequest, PatchedPrintJobRequest, PatchedPrintJobTypedRequest, PatchedPrinterReservationRequest, PatchedPrinterReservationTypedRequest):
        """Create an instance of PatchedPrinterReservationPolymorphicRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Union(PatchedMaintenanceJobRequest, PatchedMaintenanceJobTypedRequest, PatchedPrintJobRequest, PatchedPrintJobTypedRequest, PatchedPrinterReservationRequest, PatchedPrinterReservationTypedRequest):
        """Create an instance of PatchedPrinterReservationPolymorphicRequest from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = getattr(printnanny_factory_rest_api.models, object_type)
            return klass.from_dict(obj)
        else:
            raise ValueError("PatchedPrinterReservationPolymorphicRequest failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

